#ifndef BUILDING_H
#define BUILDING_H

#include <vector>
#include "vector.hpp"
#include "mesh.h"
#include "polygone.h"
#include "utility.h"
#include "floor.h"
#include "roof.h"

class Building {
public:
    Building(const Polygone &);

    inline const Polygone & getSurface() const {
        return surface;
    }

    inline const std::vector<Floor> & getFloors() const {
        return floors;
    }
    
    inline int getFloorCount() const {
        return floors.size();
    }

    inline const Roof & getRoof() const {
        return roof;
    }

    /*inline int getType() const {
        return type;
    }*/

    void grammaire(const vector3D &);

    void createMesh(Mesh&) const;
    
    friend std::ostream & operator <<(std::ostream &, const Building &);

protected:
private:
    const Polygone surface;
    std::vector<Floor> floors;
    Roof roof;
    //ajout
    //int type[MAX_FLOORS_BUILDING];
    int type;
};




#endif //BUILDING_H
