#ifndef FLOOR_H
#define FLOOR_H

#include <vector>
#include "vector.hpp"
#include "mesh.h"
#include "polygone.h"
#include "utility.h"

class Floor {
public:
    Floor(const Polygone&, int, int);
    
    inline const Polygone & getSurface() const {
        return surface;
    }
    
    inline int getType() const {
        return type;
    }
    
    inline int getLevel() const {
        return level;
    }

    void createMesh(Mesh&) const;

    void addBalcon(Mesh& , int) const;    
    void addWindows(Mesh& , int) const;    

    friend std::ostream & operator <<(std::ostream &, const Floor &);

private:
    Polygone surface;
    int type;
    int level;
};

#endif //FLOOR_H
