#ifndef INDEXMESH_H
#define INDEXMESH_H

#include <vector>
#include <cmath>
#include <iostream>
#include <fstream>
#include <sstream>

#include "vector.hpp"

class IndexMesh {
private:
    int indices[3]; //indices
    std::string color;
    

public:

    inline IndexMesh(int f1, int f2, int f3, std::string c = "default") : indices{f1, f2, f3}, color(c) {
      
    }
    
    inline IndexMesh(const IndexMesh & indexMesh) : indices{indexMesh.indices[0], indexMesh.indices[1], indexMesh.indices[2]}, color(indexMesh.color) {
        
    }

    inline const int & operator[](int i) const {
        return indices[i];
    }

    inline int & operator[](int i) {
        return indices[i];
    }

    inline const std::string & getColor() const{
      return color;
    }
};

#endif //INDEXMESH_H
