#ifndef ROAD_H
#define ROAD_H

#include <time.h>
#include <stdlib.h>
#include <iostream>
#include "vector.hpp"
#include "utility.h"

class Road {
public:
    Road(const vector3D&, const vector3D&, double = MIN_WIDTH_ROAD);
    Road(const Road&);
    ~Road();

    inline const vector3D & getStart() const {
        return start;
    }

    inline const vector3D & getEnd() const {
        return end;
    }

    inline double getWidth() const {
        return width;
    }

    void randomize(double = MIN_WIDTH_ROAD, double = MAX_WIDTH_ROAD);

    friend std::ostream & operator<<(std::ostream &, const Road &);

protected:
private:
    vector3D start;
    vector3D end;
    double width;
};



#endif //ROAD_H
