#ifndef ROOF_H
#define ROOF_H

#include <vector>
#include "vector.hpp"
#include "mesh.h"
#include "polygone.h"
#include "utility.h"

class Roof {
public:
    Roof();
    Roof(const Polygone&, int, int);
    
    inline const Polygone & getSurface() const {
        return surface;
    }
    
    inline int getType() const {
        return type;
    }
    
    inline int getLevel() const {
        return level;
    }

    void createMesh(Mesh&) const;
    
    friend std::ostream & operator <<(std::ostream &, const Roof &);

private:
    Polygone surface;
    int type;
    int level;
};

#endif //ROOF_H
