#ifndef TRIANGLE_H
#define TRIANGLE_H



#include <iostream>
#include <ctime>  
#include <cstdlib>
#include <cmath>
#include "vector.hpp"
#include "polygone.h"
#include "quadrangle.h"
#include "utility.h"

class Polygone;

class Triangle {
public:
    Triangle();
    ~Triangle();
    Triangle(const Triangle&);
    Triangle(const vector3D&, const vector3D&, const vector3D&);

    inline vector3D const & operator[](int i) const {
        return points[i];
    }

    inline vector3D & operator[](int i) {
        return points[i];
    }

    inline vector3D const * const getPoints() const {
        return points;
    }

    inline double area() const {
        return 0.5 * Norm((points[0] - points[1]) / (points[0] - points[2]));
    }

    void grammaire(std::vector<Polygone>&) const;

    friend std::ostream & operator <<(std::ostream &, const Triangle &);

protected:
    vector3D points[3];
private:

};

#endif //TRIANGLE_H
