#include "city.h"

City::City() {
}

City::~City() {
}

int City::init(Mesh& m) {
  //Districts division
  std::cout << "Initializing land and computing for district divisions..." << std::endl;
  land = Quadrangle(vector3D(0, 0, 0),
		    vector3D(0, LENGTH_CITY, 0),
		    vector3D(WIDTH_CITY, LENGTH_CITY, 0),
		    vector3D(WIDTH_CITY, 0, 0));
  land.grammaire(surfaces);
  std::cout << "District division computed ! Total divisions: " << surfaces.size() << std::endl;
  //City center
  cityCenter = vector3D(rand() % static_cast<int> (WIDTH_CITY * 0.9 - (0.0 + WIDTH_CITY * 0.1) + 1.0) + (0.0 + WIDTH_CITY * 0.1),
			rand() % static_cast<int> (LENGTH_CITY * 0.9 - (0.0 + LENGTH_CITY * 0.1) + 1.0) + (0.0 + LENGTH_CITY * 0.1),
			0);
  vector3D hSideWalk(0,0,SIDEWALK_SURELEVATION);
  //Buildings division
  std::cout << "Computing buildings division..." << std::endl;
  for (int i = 0; i < surfaces.size(); i++) {
    if (surfaces[i].reduce(WIDTH_ROAD_WAY/*(rand() % (MAX_WIDTH_ROAD - MIN_WIDTH_ROAD + 1) + MIN_WIDTH_ROAD) / 2*/, -1)) { //TODO a moduler plus proprement
      Polygone sideWalk = raiseSurface( hSideWalk,surfaces[i],m,"sidewalk");      
      sideWalk.reduce((rand() % (MAX_WIDTH_SIDEWALK - MIN_WIDTH_SIDEWALK) + MIN_WIDTH_SIDEWALK) , -1);
      addBuilding(sideWalk, m);
    }else{
      surfaces[i].reduce(WIDTH_ROAD_WAY, 1); //TODO a moduler plus proprement
      Polygone sideWalk = raiseSurface( hSideWalk,surfaces[i],m,"sidewalk");      
      sideWalk.reduce((rand() % (MAX_WIDTH_SIDEWALK - MIN_WIDTH_SIDEWALK) + MIN_WIDTH_SIDEWALK) , 1);
      addBuilding(sideWalk, m);
    }       
  }
  std::cout << "Buildings division computed ! (total buildings: " << buildings.size() << ")" << std::endl;
  return 1;
}

void City::addBuilding(const Polygone& surface, Mesh& m) {
  /* récuperer le mode de division de la surface :
   * 0 : surface non valide pour batiment
   * 1 : surface valide sans division
   * 2 : surface valide avec division
   */
  int valide = checkSurface(surface);
  int sens;

  if (valide) {
    if (valide >= 2) {

      //verifier que la longueur de chaque côté soit suffisante (en théorie inutile)
      if (valide == 2){
	valide = 3;
	for (int i = 0; i < surface.size(); i++) {
	  if (Norm(surface[(i + 1 == surface.size()) ? 0 : i + 1] - surface[i]) < MIN_WIDTH_BUILDING * 3) {
	    valide = 2;
	  }
	}
      }
	
      if (valide == 3) {
	Polygone centre(surface);
	if (centre.reduce(MIN_WIDTH_BUILDING, -1)) {
	  sens = 1;
	} else if (centre.reduce(MIN_WIDTH_BUILDING, 1)) {               
	  sens = -1;
	}

	//regarder la proportion du centre
	if (centre.area() / surface.area()*100 > MIN_RATIO_BUILDING_GARDEN and centre.area() / surface.area()*100 < MAX_RATIO_BUILDING_GARDEN) {
	  splitSurfaceGarden(surface, centre, sens, m);
	} else {
	  valide = 2;
	}
      }
      if (valide == 2) {
	//pas de reduction mais la surface est assez grande pour contenir plusieurs immeubles
	splitSurface(surface, m);
      }

    } else {
      //pas de réduction, mais la surface est assez grande pour 1 immeuble
      buildings.push_back(Building(surface));
    }
  } else {
    //pas d'immeuble, donc jardin
    vector3D h(0, 0, GARDEN_SURELEVATION);
    Polygone res = raiseSurface( h,surface,m,"green");

  //un petit sapin....
    if(surface.size()==4){
      line diag1(surface[0], surface[2]);
      line diag2(surface[1], surface[3]);
      vector3D e = diag1.intersect(diag2);
      m.addCylinder(e, vector3D(e[0], e[1], e[2] + 2),  0.2);
      m.addCone(vector3D(e[0], e[1], e[2] + 2), vector3D(e[0], e[1], e[2] + 8),  3, 20 ,"green");
    }else{
	vector3D pt1((surface[0] + surface[1]) / 2);
	vector3D pt2((surface[1] + surface[2]) / 2);
	line d1(surface[2], pt1);
	line d2(surface[0], pt2);
	vector3D e = d1.intersect(d2);
	m.addCylinder(e, vector3D(e[0], e[1], e[2] + 2),  0.2);
	m.addCone(vector3D(e[0], e[1], e[2] + 2), vector3D(e[0], e[1], e[2] + 8),  3, 20 ,"green");
    }

    
  }

}

Polygone City::raiseSurface( const vector3D& hSideWalk, const Polygone& s, Mesh& m, std::string color) {
  Polygone surface(s);
  surface+=hSideWalk;
  if (surface.size() == 3) {
    m.addTriangle(surface[0] , surface[1] , surface[2],color);
    m.addQuad(surface[0], surface[1], surface[1]-hSideWalk, surface[0]-hSideWalk,color);
    m.addQuad(surface[1], surface[2], surface[2]-hSideWalk, surface[1]-hSideWalk,color);
    m.addQuad(surface[2], surface[0], surface[0]-hSideWalk, surface[2]-hSideWalk,color);
  } else {
    m.addQuad(surface[0], surface[1], surface[2], surface[3],color);
    m.addQuad(surface[0], surface[1], surface[1]-hSideWalk, surface[0]-hSideWalk,color);
    m.addQuad(surface[1], surface[2], surface[2]-hSideWalk, surface[1]-hSideWalk,color);
    m.addQuad(surface[2], surface[3], surface[3]-hSideWalk, surface[2]-hSideWalk,color);
    m.addQuad(surface[3], surface[0], surface[0]-hSideWalk, surface[3]-hSideWalk,color);
  }
  return surface;
}

void City::splitSurfaceGarden(const Polygone& surface, const Polygone& centre, int sens, Mesh& m) {
  double mTmp, max = 0;
  int iTmp, check;
  std::vector<Polygone> freeSurfaces; // pour enregistrer les surfaces lires entre les polygones
  for (int i = 0; i < centre.size(); i++) {
    freeSurfaces.push_back(Polygone(Quadrangle()));
  }

  vector3D h(0, 0, GARDEN_SURELEVATION);
  raiseSurface( h,centre,m,"green");  

  //un petit sapin....
    if(centre.size()==4){
      line diag1(centre[0], centre[2]);
      line diag2(centre[1], centre[3]);
      vector3D e = diag1.intersect(diag2);
      m.addCylinder(e, vector3D(e[0], e[1], e[2] + 2),  0.2);
      m.addCone(vector3D(e[0], e[1], e[2] + 2), vector3D(e[0], e[1], e[2] + 8),  3, 20 ,"green");
    }else{
	vector3D pt1((centre[0] + centre[1]) / 2);
	vector3D pt2((centre[1] + centre[2]) / 2);
	line d1(centre[2], pt1);
	line d2(centre[0], pt2);
	vector3D e = d1.intersect(d2);
	m.addCylinder(e, vector3D(e[0], e[1], e[2] + 2),  0.2);
	m.addCone(vector3D(e[0], e[1], e[2] + 2), vector3D(e[0], e[1], e[2] + 8), 3, 20 ,"green");
    }

  //pour chaque point du polygone centrale
  //trouver son projeté orthogonale sur les droites ( pi, pi+1 ) et ( pi+1, pi+2 )
  //créer le building
  for (int i = 0; i < centre.size(); i++) {
    Polygone tmp;
    //ajouter le point i
    tmp.push_back(centre[i]);
    vector3D v2(centre[(i - 1 < 0) ? centre.size() - 1 : i - 1 ] - centre[i]);
    vector3D v1(centre[(i + 1 == centre.size()) ? 0 : i + 1] - centre[i]);


    //prendre projetté orthogonale de v1 sur le vecteur (pi+1,pi+2)
    {
      double y = v1[1] * -1;
      v1[1] = v1[0];
      v1[0] = y;
      vector3D n = Normalized(v1);
      vector3D p = centre[i] - 1 * n;
      line l1(centre[i], p);
      line l2(surface[(i + 2 >= surface.size()) ? i + 2 - surface.size() : i + 2], surface[(i + 1 == surface.size()) ? 0 : i + 1]);
      vector3D pTmp(l1.intersect(l2));
      tmp.push_back(pTmp);
    }
    //prendre le point correspondant sur la surface (soit pi+1)
    tmp.push_back(surface[(i + 1 == surface.size()) ? 0 : i + 1]);

    //prendre projetté orthogonale de v1 sur le vecteur (pi,pi+1)
    {
      double y = v2[1] * -1;
      v2[1] = v2[0];
      v2[0] = y;
      vector3D n = Normalized(v2);
      vector3D p = centre[i] - 1 * n;
      line l1(centre[i], p);
      line l2(surface[(i + 1 == surface.size()) ? 0 : i + 1], surface[i]);
      vector3D pTmp(l1.intersect(l2));
      tmp.push_back(pTmp);
    }
    freeSurfaces[i][0] = tmp[0];
    freeSurfaces[i][3] = tmp[1];
    freeSurfaces[(i - 1 < 0) ? freeSurfaces.size() - 1 : i - 1][1] = tmp[0];
    freeSurfaces[(i - 1 < 0) ? freeSurfaces.size() - 1 : i - 1][2] = tmp[3];

    buildings.push_back(Building(tmp));
  }
  for (int i = 0; i < freeSurfaces.size(); i++) {
    splitSurface(freeSurfaces[i], m, 1, 1);
  }

}

void City::splitSurface(const Polygone& surface, Mesh& m, int base, int end) {
  //regarder si on peu diviser le côté le plus court.
  //si oui le faire.
  //si non rien
  // diviser la côté le plus long en batiments de tailles */- aléatoire... en se basant sur origine iTmp-Normalized(iTmp+1) * size
  //dans le cas d'un triagle, essayer d'avoir des quad (1 a chaque angle + intermediaire si place), si pas la place juste 1 quad + 1 triangle
  double min = LENGTH_CITY;
  double length, lengthTmp, remove, mTmp, max = 0;
  Polygone p1, p2;
  int iTmp, iTmpMax, iTmpMin, check, baseTmp = base, div3 = 0, div2 = 0;
  //parcourir les façades, ne garder que celles à diviser (2 opposées sauf pour triangle)


  if (surface.size() == 3) {
    buildings.push_back(Building(surface));

    //prendre chacun des côtés, si ils peuent tous être découpé en plus de 2 immeubles faire +/- comme splitSurfaceGarden
    //sinon faire une coupe +/- // à un des côté, puis spliter le côté quad si assez de place
    // sinon laisser comme ça.
    for (int i = 0; i < surface.size(); i++) {
      mTmp = Norm(surface[(i + 1 == surface.size()) ? 0 : i + 1] - surface[i]);
      if (mTmp >= MIN_WIDTH_BUILDING * 3) {
	div3++;
      } else if (mTmp >= MIN_WIDTH_BUILDING * 2) {
	div2++;
      }
      if (mTmp > max) {
	max = mTmp;
	iTmpMax = i;
      }
      if (mTmp < min) {
	min = mTmp;
	iTmpMin = i;
      }
    }
    for (int i = 0; i < surface.size(); i++) {
      iTmp = (i != iTmpMax and i != iTmpMin) ? i : iTmp;
    }
    if (div3 > 1 and div2 > 0) {
      vector3D pt1((surface[iTmpMax] + surface[(iTmpMax - 1 < 0) ? surface.size() - 1 : iTmpMax - 1]) / 2);
      vector3D pt2((surface[iTmpMax] + surface[(iTmpMax + 1 == surface.size()) ? 0 : iTmpMax + 1]) / 2);
      p1.push_back(surface[iTmpMax]);
      p1.push_back(pt1);
      p1.push_back(pt2);

      p2.push_back(surface[(iTmpMax - 1 < 0) ? surface.size() - 1 : iTmpMax - 1]);
      p2.push_back(pt1);
      p2.push_back(pt2);
      p2.push_back(surface[(iTmpMax + 1 == surface.size()) ? 0 : iTmpMax + 1]);

      buildings.push_back(Building(p1));
      buildings.push_back(Building(p2));

    } else {
      /*int r = rand() % 100;
	if (r >= 50) {

	vector3D pt1((surface[0] + surface[1]) / 2);
	vector3D pt2((surface[1] + surface[2]) / 2);
	line d1(surface[2], pt1);
	line d2(surface[0], pt2);
	vector3D pt(d1.intersect(d2));
	double ray = 2 * surface.area() / (Norm(surface[1] - surface[0]) + Norm(surface[2] - surface[1]) + Norm(surface[0] - surface[2]));
	m.addCylinder(pt, vector3D(pt[0], pt[1], pt[2] + 30), ray);
	} else {*/
      buildings.push_back(Building(surface));
      //}
    }
  } else if (surface.size() == 4) {

    for (int i = 0; i < surface.size() / 2; i++) {
      mTmp =  Norm(surface[i + 1] - surface[i]) +
	Norm(
	     surface[(surface.size() / 2 + i + 1 >= surface.size()) ? 1 - 1 : surface.size() / 2 + i + 1 ] -
	     surface[(surface.size() / 2 + i >= surface.size()) ? 0 : surface.size() / 2 + i]
	     );
      if (mTmp < min) {
	min = mTmp;
	iTmp = i;
      }
    }
    if (Norm(surface[iTmp + 1] - surface[iTmp]) / 2 >= MIN_WIDTH_BUILDING) {
      for (int i = 0; i < surface.size(); i++) {
	if (i <= iTmp or i > iTmp + surface.size() / 2) {
	  p1.push_back(surface[i]);
	} else/* if(i>iTmp and i<=iTmp + surface.size()/2)*/ {
	  p2.push_back(surface[i]);
	}
	if (i == iTmp or i == iTmp + surface.size() / 2) {
	  vector3D p = surface[i] + (surface[(i + 1 == surface.size()) ? 0 : i + 1] - surface[i]) / 2;
	  p1.push_back(p);
	  p2.push_back(p);
	}
      }

      {
	max = 0;
	for (int i = 0; i < p1.size() / 2 + 1; i++) {
	  mTmp =  Norm(p1[i + 1] - p1[i]) +
	    Norm(
		 p1[(p1.size() / 2 + i + 1 >= p1.size()) ? 1 - 1 : p1.size() / 2 + i + 1 ] -
		 p1[(p1.size() / 2 + i >= p1.size()) ? 0 : p1.size() / 2 + i]
		 );
	  if (mTmp > max) {
	    max = mTmp;
	    iTmp = i;
	  }
	}
	lengthTmp = 0;
	length = Norm(p1[(iTmp + 1 == p1.size()) ? 0 : iTmp + 1] - p1[iTmp]);

	vector3D vPt0 = p1[iTmp];
	vector3D vPt3 = p1[(iTmp - 1 < 0) ? p1.size() - 1 : iTmp - 1];
	while (length > lengthTmp) {
	  Polygone pTmp;
	  remove = (rand() % (MAX_WIDTH_BUILDING - MIN_WIDTH_BUILDING + 1) + MIN_WIDTH_BUILDING);
	  if (length - (lengthTmp + remove) > MIN_WIDTH_BUILDING) {
	    lengthTmp += remove;
	  } else {
	    lengthTmp = length;
	  }
	  vector3D vPt1 = p1[iTmp] + Normalized(p1[(iTmp + 1 == p1.size()) ? 0 : iTmp + 1] - p1[iTmp]) * lengthTmp;
	  vector3D vPt2 = p1[(iTmp - 1 < 0) ? p1.size() - 1 : iTmp - 1] + Normalized(p1[(iTmp - 2 < 0) ? ((iTmp - 1 < 0) ? p1.size() - 2 : p1.size() - 1) : iTmp - 2] - p1[(iTmp - 1 < 0) ? p1.size() - 1 : iTmp - 1]) * lengthTmp * (Norm(p1[(iTmp - 2 < 0) ? ((iTmp - 1 < 0) ? p1.size() - 2 : p1.size() - 1) : iTmp - 2] - p1[(iTmp - 1 < 0) ? p1.size() - 1 : iTmp - 1]) / Norm(p1[(iTmp + 1 == p1.size()) ? 0 : iTmp + 1] - p1[iTmp]));

	  pTmp.push_back(vPt0);
	  pTmp.push_back(vPt1);
	  pTmp.push_back(vPt2);
	  pTmp.push_back(vPt3);

	  buildings.push_back(Building(pTmp));
	  vPt0 = vPt1;
	  vPt3 = vPt2;
	}

      }
      {
	max = 0;
	for (int i = 0; i < p2.size() / 2 + 1; i++) {
	  mTmp =  Norm(p2[i + 1] - p2[i]) +
	    Norm(
		 p2[(p2.size() / 2 + i + 1 >= p2.size()) ? 1 - 1 : p2.size() / 2 + i + 1 ] -
		 p2[(p2.size() / 2 + i >= p2.size()) ? 0 : p2.size() / 2 + i]
		 );
	  if (mTmp > max) {
	    max = mTmp;
	    iTmp = i;
	  }
	}

	lengthTmp = 0;
	length = Norm(p2[(iTmp + 1 == p2.size()) ? 0 : iTmp + 1] - p2[iTmp]);
	vector3D vPt0 = p2[iTmp];
	vector3D vPt3 = p2[(iTmp - 1 < 0) ? p2.size() - 1 : iTmp - 1];
	while (length > lengthTmp) {
	  Polygone pTmp;
	  remove = (rand() % (MAX_WIDTH_BUILDING - MIN_WIDTH_BUILDING + 1) + MIN_WIDTH_BUILDING);
	  if (length - (lengthTmp + remove) > MIN_WIDTH_BUILDING) {
	    lengthTmp += remove;
	  } else {
	    lengthTmp = length;
	  }
	  vector3D vPt1 = p2[iTmp] + Normalized(p2[(iTmp + 1 == p2.size()) ? 0 : iTmp + 1] - p2[iTmp]) * lengthTmp;
	  vector3D vPt2 = p2[(iTmp - 1 < 0) ? p2.size() - 1 : iTmp - 1] + Normalized(p2[(iTmp - 2 < 0) ? ((iTmp - 1 < 0) ? p2.size() - 2 : p2.size() - 1) : iTmp - 2] - p2[(iTmp - 1 < 0) ? p2.size() - 1 : iTmp - 1]) * lengthTmp * (Norm(p2[(iTmp - 2 < 0) ? ((iTmp - 1 < 0) ? p2.size() - 2 : p1.size() - 1) : iTmp - 2] - p2[(iTmp - 1 < 0) ? p2.size() - 1 : iTmp - 1]) / Norm(p2[(iTmp + 1 == p2.size()) ? 0 : iTmp + 1] - p2[iTmp]));

	  pTmp.push_back(vPt0);
	  pTmp.push_back(vPt1);
	  pTmp.push_back(vPt2);
	  pTmp.push_back(vPt3);

	  buildings.push_back(Building(pTmp));
	  vPt0 = vPt1;
	  vPt3 = vPt2;
	}

      }
           
    } else {
      for (int i = 0; i < surface.size() / 2 + 1; i++) {
	mTmp =  Norm(surface[i + 1] - surface[i]) +
	  Norm(
	       surface[(surface.size() / 2 + i + 1 >= surface.size()) ? 1 - 1 : surface.size() / 2 + i + 1 ] -
	       surface[(surface.size() / 2 + i >= surface.size()) ? 0 : surface.size() / 2 + i]
	       );
	if (mTmp > max) {
	  max = mTmp;
	  iTmp = i;
	}
      }
      lengthTmp = 0;
      length = Norm(surface[(iTmp + 1 == surface.size()) ? 0 : iTmp + 1] - surface[iTmp]);

      vector3D vPt0 = surface[iTmp];
      vector3D vPt3 = surface[(iTmp - 1 < 0) ? surface.size() - 1 : iTmp - 1];
      while (length > lengthTmp) {
	Polygone pTmp;
	remove = (rand() % (MAX_WIDTH_BUILDING - MIN_WIDTH_BUILDING + 1) + MIN_WIDTH_BUILDING);
	if (length - (lengthTmp + remove) > MIN_WIDTH_BUILDING) {
	  lengthTmp += remove;
	} else {
	  lengthTmp = length;
	}
	vector3D vPt1 = surface[iTmp] + Normalized(surface[(iTmp + 1 == surface.size()) ? 0 : iTmp + 1] - surface[iTmp]) * lengthTmp;
	vector3D vPt2 = surface[(iTmp - 1 < 0) ? surface.size() - 1 : iTmp - 1] + Normalized(surface[(iTmp - 2 < 0) ? ((iTmp - 1 < 0) ? surface.size() - 2 : surface.size() - 1) : iTmp - 2] - surface[(iTmp - 1 < 0) ? surface.size() - 1 : iTmp - 1]) * lengthTmp * (Norm(surface[(iTmp - 2 < 0) ? ((iTmp - 1 < 0) ? surface.size() - 2 : surface.size() - 1) : iTmp - 2] - surface[(iTmp - 1 < 0) ? surface.size() - 1 : iTmp - 1]) / Norm(surface[(iTmp + 1 == surface.size()) ? 0 : iTmp + 1] - surface[iTmp]));

	pTmp.push_back(vPt0);
	pTmp.push_back(vPt1);
	pTmp.push_back(vPt2);
	pTmp.push_back(vPt3);

	buildings.push_back(Building(pTmp));
	vPt0 = vPt1;
	vPt3 = vPt2;
      }
    }
  }

}

/**
 * 0 : non valide
 * 1 : valide pour 1 batiment
 * 2 : valide, ok pour test réduction
 */
int City::checkSurface(const Polygone& surface) {

  double angle, angle2, height, need = 0.0;
  int valide = 2;
  /*
   * Vérification : 
   * triangle :
   * vérifier les angles et les hauteurs. Les angles doivent être dans l'intervale défini, ainsi que chacune des hauteurs
   * Dés que l'on a un angle très aigue, il faut obligatoirement que les 2 autres soient à 20% egaux 
   */
  if (surface.size() == 3) {
    //calcule de l'angle u.v avec u =(pi o) et v = (pi+1 o)
    vector3D u(surface[0][0] - surface[1][0], surface[0][1] - surface[1][1], 0);
    vector3D v(surface[0][0] - surface[2][0], surface[0][1] - surface[2][1], 0);
    angle = (180 / M_PI) * acos((u * v) / (Norm(u) * Norm(v)));
    height = Norm(u.scale(v)) / Norm(v);
    if (angle < MIN_BUILDING_TRI_ANGLE or height < MIN_BUILDING_TRI_HEIGHT) valide = 0;
    else if (height <= MIN_WIDTH_BUILDING * 2) valide = 1;

    if (need > 0) {
      if (angle < need * 0.8 or angle > need * 1.2) {
	valide = 1;
      }
    } else if (angle < MIN_BUILDING_TRI_ANGLE * 1.5) {
      need = (180.0 - angle) / 2.0;
    }
    if (valide == 2) {
      //calcule de l'angle u.v avec u =(pi+1 o) et v = (pi+2 o)
      vector3D u(surface[1][0] - surface[2][0], surface[1][1] - surface[2][1], 0);
      vector3D v(surface[1][0] - surface[0][0], surface[1][1] - surface[0][1], 0);
      angle = (180 / M_PI) * acos((u * v) / (Norm(u) * Norm(v)));
      height = Norm(u.scale(v)) / Norm(v);
      if (angle < MIN_BUILDING_TRI_ANGLE or height < MIN_BUILDING_TRI_HEIGHT) {
	valide = 0;
      }
      else if (height <= MIN_WIDTH_BUILDING * 2) {
	valide = 1;
      }
      if (need > 0) {
	if (angle < need * 0.8 or angle > need * 1.2) {
	  valide = 1;
	}
      } else if (angle < MIN_BUILDING_TRI_ANGLE * 1.5) {
	need = (180.0 - angle) / 2.0;
      }
    }
    if (valide == 2) {
      //calcule de l'angle u.v avec u =(pi o) et v = (pi+1 o)
      vector3D u(surface[2][0] - surface[0][0], surface[2][1] - surface[0][1], 0);
      vector3D v(surface[2][0] - surface[1][0], surface[2][1] - surface[1][1], 0);
      angle = (180 / M_PI) * acos((u * v) / (Norm(u) * Norm(v)));
      height = Norm(u.scale(v)) / Norm(v);
      if (angle < MIN_BUILDING_TRI_ANGLE or height < MIN_BUILDING_TRI_HEIGHT) {
	valide = 0;
      } else if (height <= MIN_WIDTH_BUILDING * 2) {
	valide = 1;
      }

      if (need > 0) {
	if (angle < need * 0.8 or angle > need * 1.2) valide = 1;
      } else if (angle < MIN_BUILDING_TRI_ANGLE * 1.5) {
	need = (180.0 - angle) / 2.0;
      }
    }
    if (valide == 2 and need > 0) {
      valide = 1;
    }
  }
  if (surface.size() == 4) {
    //Controler la longueur min des diagonales
    if (Norm(surface[2] - surface[0]) >= MIN_BUILDING_QUAD_DIAGONAL and Norm(surface[3] - surface[1]) >= MIN_BUILDING_QUAD_DIAGONAL) {
      line diag1(surface[0], surface[2]);
      line diag2(surface[1], surface[3]);
      vector3D o = diag1.intersect(diag2);
      //Si l'angle est trop petit/grand et les diagonales trop petites, alors return 0, 
      {
	//calcule de l'angle u.v avec u =(pi o) et v = (pi+1 o)
	vector3D u(surface[0][0] - o[0], surface[0][1] - o[1], 0);
	vector3D v(surface[1][0] - o[0], surface[1][1] - o[1], 0);
	angle = (180 / M_PI) * acos((u * v) / (Norm(u) * Norm(v)));
      }

      if ((Norm(surface[2] - surface[0]) < MIN_BUILDING_QUAD_DIAGONAL and Norm(surface[3] - surface[1]) <= MIN_BUILDING_QUAD_DIAGONAL) and (angle < MIN_BUILDING_QUAD_ANGLE or angle > MAX_BUILDING_QUAD_ANGLE)) {
	valide = 1;
      }else if (Norm(surface[2] - surface[0]) <= MIN_BUILDING_QUAD_DIAGONAL*2 and Norm(surface[3] - surface[1]) <= MIN_BUILDING_QUAD_DIAGONAL*2){
	valide = 2;
      }
    } else {
      valide = 0;
    }
  }
  return valide;
}

void City::createMesh(Mesh& m) {
  m.addQuad(vector3D(0, 0, 0), vector3D(WIDTH_CITY, 0, 0), vector3D(WIDTH_CITY, LENGTH_CITY, 0), vector3D(0, LENGTH_CITY, 0),"road");
  std::cout << "Computing buildings elevation..." << std::endl;
  int avgLevel = 0, minLevel = MAX_FLOORS_BUILDING, maxLevel = 0;
  for (std::vector<Building>::iterator it = buildings.begin(); it != buildings.end(); it++) {
    it->grammaire(cityCenter);
    if (it->getFloorCount() > maxLevel) {
      maxLevel = it->getFloorCount();
    }
    if (it->getFloorCount() < minLevel) {
      minLevel = it->getFloorCount();
    }
    avgLevel += it->getFloorCount();
    it->createMesh(m);
  }
  avgLevel /= buildings.size();
  std::cout << "Building elevation computed ! Buildings height (min/avg/max): " << minLevel << "/" << avgLevel << "/" << maxLevel << std::endl;
}
