#include "line.h"

line::line() {
}

line::~line() {
}

line::line(const vector3D& a, const vector3D& b) :a(a), b(b) {
    
}

/**
 *
 */
vector3D line::intersect(const line& d) {

    // Store the values for fast access and easy
    // equations-to-code conversion
    double x1 = a[0], x2 = b[0], x3 = d.a[0], x4 = d.b[0];
    double y1 = a[1], y2 = b[1], y3 = d.a[1], y4 = d.b[1];

    double delta = (x1 - x2) * (y3 - y4) - (y1 - y2) * (x3 - x4);
    // If d is zero, there is no intersection
    if (delta == 0) throw "Les 2 droites sont paralleles"; //return NULL;

    // Get the x and y
    double pre = (x1 * y2 - y1 * x2), post = (x3 * y4 - y3 * x4);
    double x = (pre * (x3 - x4) - (x1 - x2) * post) / delta;
    double y = (pre * (y3 - y4) - (y1 - y2) * post) / delta;

    // Check if the x and y coordinates are within both lines
    /*if ( x < min(x1, x2) || x > max(x1, x2) ||
    x < min(x3, x4) || x > max(x3, x4) ) return NULL;
    if ( y < min(y1, y2) || y > max(y1, y2) ||
    y < min(y3, y4) || y > max(y3, y4) ) return NULL;
     */
    // Return the point of intersection

    return vector3D(x, y, (a[2]+b[2])/2);
   
}

std::ostream & operator <<(std::ostream & os, const line & d) {
    return os << "line{" << d.a << ", " << d.b << "}" << std::endl;
}
