#include <cmath>   
#include <cstdlib> 
#include <cstdio>  
#include <vector>
#include <ctime>
#include <pthread.h>
#include <unistd.h>
#include <sys/time.h>


#include "vector.hpp"
#include "city.h"
#include "mesh.h"
#include "quadrangle.h"

static void show_usage(std::string name) {
    std::cerr << "Usage: " << name << " TODO" << std::endl;
}

int main(int argc, char *argv[]) {
    srand(time(0));
  struct timeval time;
  gettimeofday(&time, 0);
  double t1 = time.tv_sec+(time.tv_usec/1000000.0);
 
  for (int i = 1; i < argc; ++i) {
    std::string arg = argv[i];
  }



    //Initialiser les différents paramètres de la ville
    //créer le graphe en fonction des tailles de route, batiments ou autres
    //générer le plan
    City ville = City();
    Mesh m = Mesh();
    if (ville.init(m)) {
        ville.createMesh(m); //elever les batiments
	std::cout<<m;

	gettimeofday(&time, 0);
	double t2 = time.tv_sec+(time.tv_usec/1000000.0);
	std::cout<<"Generation time :  "<<(t2-t1)<<" second(s)"<<std::endl;

	m.write("test.obj");

	gettimeofday(&time, 0);
	double t3 = time.tv_sec+(time.tv_usec/1000000.0);

	std::cout<<"Writing time :  "<<(t3-t2)<<" second(s)"<<std::endl;
	
    }
    return 0;
}
