#include "polygone.h"

Polygone::Polygone(const Polygone& p) : points(p.points) {

}

Polygone::Polygone(const Triangle& t) : points {
    t[0], t[1], t[2]
}
{

}

Polygone::Polygone(const Quadrangle& q) : points {
    q[0], q[1], q[2], q[3]
}
{

}

int Polygone::reduce(int d, int s) {
    std::vector<line> droites;
    std::vector<vector3D> result;
    int xR, xP, yR, yP, valide = 1;
    for (int i = 0; i < points.size(); i++) {
        vector3D tmp = points[i + 1 == points.size() ? 0 : i + 1] - points[i]; //AB
        double y = tmp[1] * s;
        tmp[1] = tmp[0];
        tmp[0] = y;
        vector3D n = Normalized(tmp);
        vector3D p1 = points[i] - d*n;
        vector3D p2 = points[i + 1 == points.size() ? 0 : i + 1] - d*n;
        droites.push_back(line(p1, p2));
    }

    //prendre l'intersection des droites i i+1
    for (int i = 0; i < droites.size(); i++) {
        vector3D p = droites[i].intersect(droites[i + 1 == points.size() ? 0 : i + 1]);
        result.push_back(p);
    }

    
    //else {
        //verifier que l'on obtient une réduction
        //pour chaque point de points et result, verifier sa position par rapport aux autres points
        for (int i = 0; i < result.size(); i++) {
            for (int j = 0; j < result.size(); j++) {
                if (i != j) {
                    xR = result[i][0] < result[j][0] ? -1 : 1;
                    xP = points[i + 1 >= points.size() ? 0 : i + 1][0] < points[j + 1 >= points.size() ? 0 : j + 1][0] ? -1 : 1;
                    yR = result[i][1] < result[j][1] ? -1 : 1;
                    yP = points[i + 1 >= points.size() ? 0 : i + 1][1] < points[j + 1 >= points.size() ? 0 : j + 1][1] ? -1 : 1;
                    if (xR != xP or yR != yP) valide = 0;
                }
            }
        }
	//  }
	if (area(result)>this->area()) valide = 0;
    if (valide)
        this->points = result;

    return valide;
}

Polygone& Polygone::operator+=(const vector3D& u ) {
  for(int i=0;i<points.size();i++)
    points[i]+=u;
  
  return *this;
}

Polygone& Polygone::operator-=(const vector3D& u ) {
  for(int i=0;i<points.size();i++)
    points[i]-=u;

  return *this;
}

std::ostream & operator <<(std::ostream & os, const Polygone & polygone) {
    os << "polygone(";
    for (int i = 0; i < polygone.points.size(); i++) {
        os << polygone.points[i];
        if (i < polygone.points.size() - 1) {
            os << ", ";
        }
    }
    return os << ")" << std::endl;
}
