#include "triangle.h"

Triangle::Triangle() {
}

Triangle::~Triangle() {
}

Triangle::Triangle(const Triangle& t) : points(t.points) {

}

Triangle::Triangle(const vector3D& v1, const vector3D& v2, const vector3D& v3) : points {
    v1, v2, v3
}
{

}

void Triangle::grammaire(std::vector<Polygone> & list) const {
    double surface = area();
    if (stopDivision(TRIANGLE_SURF_MIN, TRIANGLE_SURF_MAX, surface)) { //Stopper la division si surface trop petite ou si probabilite d'arret
        list.push_back(Polygone(*this));
    } else {
        int random = rand() % 100;
        double dist01 = Norm(points[0] - points[1]);
        double dist12 = Norm(points[1] - points[2]);
        double dist20 = Norm(points[2] - points[0]);
        if (random < T_TT) { //T -> TT division
            //Couper le triangle à partir du point opposé au coté le plus grand
            int pointToCut;
            if (dist01 < dist12) {
                if (dist12 < dist20) {
                    pointToCut = 1;
                } else {
                    pointToCut = 0;
                }
            } else {
                if (dist01 < dist20) {
                    pointToCut = 1;
                } else {
                    pointToCut = 2;
                }
            }
            double edgeCutRatio = getEdgeCutRatio();
            Triangle(points[pointToCut],
                    points[(pointToCut + 1) % 3],
                    points[(pointToCut + 1) % 3] + (points[(pointToCut + 2) % 3] - points[(pointToCut + 1) % 3]) * edgeCutRatio).grammaire(list);
            Triangle(points[pointToCut],
                    points[(pointToCut + 1) % 3] + (points[(pointToCut + 2) % 3] - points[(pointToCut + 1) % 3]) * edgeCutRatio,
                    points[(pointToCut + 2) % 3]).grammaire(list);
        } else { //T -> QT division
            //Couper les 2 côtés les plus grands
            int edgeNotToCut; //On cherche le cote le plus petit, celui a ne pas couper
            if (dist01 < dist12) {
                if (dist01 < dist20) {
                    edgeNotToCut = 0; //Cote 0-1
                } else {
                    edgeNotToCut = 2; //Cote 2-0
                }
            } else {
                if (dist20 < dist12) {
                    edgeNotToCut = 2; //Cote 2-0
                } else {
                    edgeNotToCut = 1; //Cote 1-2
                }
            }
            double edgeCutRatio = getEdgeCutRatio();
            Quadrangle(points[edgeNotToCut] + (points[(edgeNotToCut + 2) % 3] - points[edgeNotToCut]) * edgeCutRatio,
                    points[edgeNotToCut],
                    points[(edgeNotToCut + 1) % 3],
                    points[(edgeNotToCut + 1) % 3] + (points[(edgeNotToCut + 2) % 3] - points[(edgeNotToCut + 1) % 3]) * edgeCutRatio).grammaire(list);
            Triangle(points[(edgeNotToCut + 2) % 3],
                    points[edgeNotToCut] + (points[(edgeNotToCut + 2) % 3] - points[edgeNotToCut]) * edgeCutRatio,
                    points[(edgeNotToCut + 1) % 3] + (points[(edgeNotToCut + 2) % 3] - points[(edgeNotToCut + 1) % 3]) * edgeCutRatio).grammaire(list);
        }
    }
}

std::ostream & operator <<(std::ostream & os, const Triangle & triangle) {
    return os << "triangle(" << triangle.points[0] << ", " << triangle.points[1] << ", " << triangle.points[2] << ")";
}
